diff --git a/gcc/analyzer/supergraph.cc b/gcc/analyzer/supergraph.cc
index 01f1a9d..31609e2 100644
--- a/gcc/analyzer/supergraph.cc
+++ b/gcc/analyzer/supergraph.cc
@@ -161,8 +161,9 @@ supergraph::supergraph (logger *logger)
 	  supernode *callee_supernode
 	    = *m_bb_to_initial_node.get (callee_cfg_block);
 	  call_superedge *sedge
-	    = add_callgraph_edge (caller_prev_supernode, callee_supernode,
-				  SUPEREDGE_CALL, edge);
+	    = add_call_superedge (caller_prev_supernode,
+				  callee_supernode,
+				  edge);
 	  m_cgraph_edge_to_call_superedge.put (edge, sedge);
 	}
     }
@@ -180,9 +181,10 @@ supergraph::supergraph (logger *logger)
 	    = EXIT_BLOCK_PTR_FOR_FN (edge->callee->get_fun ());
 	  supernode *callee_supernode
 	    = *m_bb_to_initial_node.get (callee_cfg_block);
-	  call_superedge *sedge
-	    = add_callgraph_edge (callee_supernode, caller_next_supernode,
-				  SUPEREDGE_RETURN, edge);
+	  return_superedge *sedge
+	    = add_return_superedge (callee_supernode,
+				    caller_next_supernode,
+				    edge);
 	  m_cgraph_edge_to_return_superedge.put (edge, sedge);
 	}
     }
@@ -198,9 +200,12 @@ supergraph::supergraph (logger *logger)
 	  supernode *caller_prev_supernode = (*iter).second;
 	  supernode *caller_next_supernode
 	    = *m_cgraph_edge_to_caller_next_node.get (edge);
-	  add_callgraph_edge (caller_prev_supernode,
-			      caller_next_supernode,
-			      SUPEREDGE_INTRAPROCEDURAL_CALL, edge);
+	  superedge *sedge
+	    = new callgraph_superedge (caller_prev_supernode,
+				       caller_next_supernode,
+				       SUPEREDGE_INTRAPROCEDURAL_CALL,
+				       edge);
+	  add_edge (sedge);
 	}
 
     }
@@ -349,10 +354,19 @@ supergraph::add_cfg_edge (supernode *src, supernode *dest, ::edge e, int idx)
 }
 
 call_superedge *
-supergraph::add_callgraph_edge (supernode *src, supernode *dest,
-				enum edge_kind kind, cgraph_edge *cedge)
+supergraph::add_call_superedge (supernode *src, supernode *dest,
+				cgraph_edge *cedge)
+{
+  call_superedge *new_edge = new call_superedge (src, dest, cedge);
+  add_edge (new_edge);
+  return new_edge;
+}
+
+return_superedge *
+supergraph::add_return_superedge (supernode *src, supernode *dest,
+				  cgraph_edge *cedge)
 {
-  call_superedge *new_edge = new call_superedge (src, dest, kind, cedge);
+  return_superedge *new_edge = new return_superedge (src, dest, cedge);
   add_edge (new_edge);
   return new_edge;
 }
@@ -655,7 +669,7 @@ superedge::get_any_cfg_edge () const
 cgraph_edge *
 superedge::get_any_callgraph_edge () const
 {
-  if (const call_superedge *sub = dyn_cast_call_superedge ())
+  if (const callgraph_superedge *sub = dyn_cast_callgraph_superedge ())
     return sub->m_cedge;
   return NULL;
 }
@@ -665,7 +679,7 @@ superedge::get_any_callgraph_edge () const
 cgraph_edge *
 superedge::get_callgraph_edge () const
 {
-  const call_superedge *sub = dyn_cast_call_superedge ();
+  const callgraph_superedge *sub = dyn_cast_callgraph_superedge ();
   gcc_assert (sub);
   return sub->m_cedge;
 }
@@ -757,7 +771,7 @@ switch_cfg_superedge::get_case_label () const
 /* FIXME.  */
 
 void
-call_superedge::dump_label_to_pp (pretty_printer *pp) const
+callgraph_superedge::dump_label_to_pp (pretty_printer *pp) const
 {
   /* FIXME.  */
   switch (m_kind)
@@ -783,7 +797,7 @@ call_superedge::dump_label_to_pp (pretty_printer *pp) const
 /* FIXME.  */
 
 tree
-call_superedge::get_callee_decl () const
+callgraph_superedge::get_callee_decl () const
 {
   return m_cedge->callee->get_fun ()->decl;
 }
@@ -791,7 +805,7 @@ call_superedge::get_callee_decl () const
 /* FIXME.  */
 
 tree
-call_superedge::get_caller_decl () const
+callgraph_superedge::get_caller_decl () const
 {
   return m_cedge->caller->get_fun ()->decl;
 }
@@ -799,7 +813,7 @@ call_superedge::get_caller_decl () const
 /* FIXME.  */
 
 tree
-call_superedge::get_arg_for_parm (tree parm_to_find) const
+callgraph_superedge::get_arg_for_parm (tree parm_to_find) const
 {
   gcc_assert  (TREE_CODE (parm_to_find) == PARM_DECL);
 
@@ -820,7 +834,7 @@ call_superedge::get_arg_for_parm (tree parm_to_find) const
 /* FIXME.  */
 
 tree
-call_superedge::get_parm_for_arg (tree arg_to_find) const
+callgraph_superedge::get_parm_for_arg (tree arg_to_find) const
 {
   tree callee = get_callee_decl ();
 
@@ -841,7 +855,7 @@ call_superedge::get_parm_for_arg (tree arg_to_find) const
 /* Map caller_expr back to an expr within the callee, or return NULL_TREE.  */
 
 tree
-call_superedge::map_expr_from_caller_to_callee (tree caller_expr) const
+callgraph_superedge::map_expr_from_caller_to_callee (tree caller_expr) const
 {
   /* Is it an argument (actual param)?  If so, convert to
      parameter (formal param).  */
@@ -858,7 +872,7 @@ call_superedge::map_expr_from_caller_to_callee (tree caller_expr) const
 /* Map callee_expr back to an expr within the caller, or return NULL_TREE.  */
 
 tree
-call_superedge::map_expr_from_callee_to_caller (tree callee_expr) const
+callgraph_superedge::map_expr_from_callee_to_caller (tree callee_expr) const
 {
   /* If it's a parameter (formal param), get the argument (actual param).  */
   if (TREE_CODE (callee_expr) == PARM_DECL)
diff --git a/gcc/analyzer/supergraph.h b/gcc/analyzer/supergraph.h
index 85b762e..f887998 100644
--- a/gcc/analyzer/supergraph.h
+++ b/gcc/analyzer/supergraph.h
@@ -26,7 +26,9 @@ along with GCC; see the file COPYING3.  If not see
 class supergraph;
 class supernode;
 class superedge;
-  class call_superedge;
+  class callgraph_superedge;
+    class call_superedge;
+    class return_superedge;
   class cfg_superedge;
     class switch_cfg_superedge;
 class dot_annotator;
@@ -106,9 +108,9 @@ public:
 	      (m_cgraph_edge_to_call_superedge).get (edge));
   }
 
-  call_superedge *get_edge_for_return (cgraph_edge *edge) const
+  return_superedge *get_edge_for_return (cgraph_edge *edge) const
   {
-    return (*const_cast <cgraph_edge_to_call_superedge_t &>
+    return (*const_cast <cgraph_edge_to_return_superedge_t &>
 	      (m_cgraph_edge_to_return_superedge).get (edge));
   }
 
@@ -131,8 +133,10 @@ private:
   supernode *add_node (function *fun, basic_block bb, gcall *returning_call,
 		       gimple_seq phi_nodes);
   superedge *add_cfg_edge (supernode *src, supernode *dest, ::edge e, int idx);
-  call_superedge *add_callgraph_edge (supernode *src, supernode *dest,
-				      enum edge_kind kind, cgraph_edge *cedge);
+  call_superedge *add_call_superedge (supernode *src, supernode *dest,
+				      cgraph_edge *cedge);
+  return_superedge *add_return_superedge (supernode *src, supernode *dest,
+					  cgraph_edge *cedge);
   superedge *add_edge (superedge *e);
 
   /* Data.  */
@@ -148,9 +152,13 @@ private:
   cgraph_edge_to_node_t m_cgraph_edge_to_caller_prev_node;
   cgraph_edge_to_node_t m_cgraph_edge_to_caller_next_node;
 
-  typedef hash_map<cgraph_edge *, call_superedge *> cgraph_edge_to_call_superedge_t;
+  typedef hash_map<cgraph_edge *, call_superedge *>
+    cgraph_edge_to_call_superedge_t;
   cgraph_edge_to_call_superedge_t m_cgraph_edge_to_call_superedge;
-  cgraph_edge_to_call_superedge_t m_cgraph_edge_to_return_superedge;
+
+  typedef hash_map<cgraph_edge *, return_superedge *>
+    cgraph_edge_to_return_superedge_t;
+  cgraph_edge_to_return_superedge_t m_cgraph_edge_to_return_superedge;
 };
 
 /* FIXME.  */
@@ -233,8 +241,12 @@ class superedge
   virtual void dump_label_to_pp (pretty_printer *pp) const = 0;
   virtual cfg_superedge *dyn_cast_cfg_superedge () { return NULL; }
   virtual const cfg_superedge *dyn_cast_cfg_superedge () const { return NULL; }
+  virtual callgraph_superedge *dyn_cast_callgraph_superedge () { return NULL; }
+  virtual const callgraph_superedge *dyn_cast_callgraph_superedge () const { return NULL; }
   virtual call_superedge *dyn_cast_call_superedge () { return NULL; }
   virtual const call_superedge *dyn_cast_call_superedge () const { return NULL; }
+  virtual return_superedge *dyn_cast_return_superedge () { return NULL; }
+  virtual const return_superedge *dyn_cast_return_superedge () const { return NULL; }
 
   ::edge get_any_cfg_edge () const;
   cgraph_edge *get_any_callgraph_edge () const;
@@ -257,21 +269,16 @@ class superedge
 
 /* A subclass of superedge corresponding to a callgraph edge.  */
 
-class call_superedge : public superedge
+class callgraph_superedge : public superedge
 {
  public:
-  call_superedge (supernode *src, supernode *dst, enum edge_kind kind,
-		  cgraph_edge *cedge)
+  callgraph_superedge (supernode *src, supernode *dst, enum edge_kind kind,
+		       cgraph_edge *cedge)
   : superedge (src, dst, kind),
     m_cedge (cedge)
   {}
 
   void dump_label_to_pp (pretty_printer *pp) const OVERRIDE;
-  call_superedge *dyn_cast_call_superedge () FINAL OVERRIDE { return this; }
-  const call_superedge *dyn_cast_call_superedge () const FINAL OVERRIDE
-  {
-    return this;
-  }
 
   tree get_callee_decl () const;
   tree get_caller_decl () const;
@@ -284,6 +291,65 @@ class call_superedge : public superedge
   cgraph_edge *m_cedge;
 };
 
+class call_superedge : public callgraph_superedge
+{
+ public:
+  call_superedge (supernode *src, supernode *dst, cgraph_edge *cedge)
+  : callgraph_superedge (src, dst, SUPEREDGE_CALL, cedge)
+  {}
+
+  callgraph_superedge *dyn_cast_callgraph_superedge () FINAL OVERRIDE
+  {
+    return this;
+  }
+  const callgraph_superedge *dyn_cast_callgraph_superedge () const
+    FINAL OVERRIDE
+  {
+    return this;
+  }
+
+  call_superedge *dyn_cast_call_superedge () FINAL OVERRIDE
+  {
+    return this;
+  }
+  const call_superedge *dyn_cast_call_superedge () const FINAL OVERRIDE
+  {
+    return this;
+  }
+
+  return_superedge *get_edge_for_return (const supergraph &sg) const
+  {
+    return sg.get_edge_for_return (m_cedge);
+  }
+};
+
+class return_superedge : public callgraph_superedge
+{
+ public:
+  return_superedge (supernode *src, supernode *dst, cgraph_edge *cedge)
+  : callgraph_superedge (src, dst, SUPEREDGE_RETURN, cedge)
+  {}
+
+  callgraph_superedge *dyn_cast_callgraph_superedge () FINAL OVERRIDE
+  {
+    return this;
+  }
+  const callgraph_superedge *dyn_cast_callgraph_superedge () const
+    FINAL OVERRIDE
+  { return this; }
+
+  return_superedge *dyn_cast_return_superedge () FINAL OVERRIDE { return this; }
+  const return_superedge *dyn_cast_return_superedge () const FINAL OVERRIDE
+  {
+    return this;
+  }
+
+  call_superedge *get_edge_for_call (const supergraph &sg) const
+  {
+    return sg.get_edge_for_call (m_cedge);
+  }
+};
+
 /* A subclass of superedge that corresponds to a CFG edge.  */
 
 class cfg_superedge : public superedge
diff --git a/gcc/testsuite/gcc.dg/analyzer/factorial.c b/gcc/testsuite/gcc.dg/analyzer/factorial.c
new file mode 100644
index 0000000..384713a
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/analyzer/factorial.c
@@ -0,0 +1,7 @@
+int factorial (int n)
+{
+  if (n > 1)
+    return n * factorial (n - 1);
+  else
+    return 1;
+}
diff --git a/gcc/testsuite/gcc.dg/analyzer/fibonacci.c b/gcc/testsuite/gcc.dg/analyzer/fibonacci.c
new file mode 100644
index 0000000..1ca3726
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/analyzer/fibonacci.c
@@ -0,0 +1,7 @@
+int fib (int n)
+{
+  if (n > 1)
+    return fib (n - 1) + fib (n - 2);
+  else
+    return n;
+}
diff --git a/gcc/testsuite/gcc.dg/analyzer/infinite-recursion.c b/gcc/testsuite/gcc.dg/analyzer/infinite-recursion.c
index 5b79fec..b770e12 100644
--- a/gcc/testsuite/gcc.dg/analyzer/infinite-recursion.c
+++ b/gcc/testsuite/gcc.dg/analyzer/infinite-recursion.c
@@ -18,3 +18,38 @@ void test(int flag)
 
   marker_D();
 }
+
+/* A cycle of 4 mutually-recursive functions (but only for certain inputs).  */
+
+extern void mutual_test_1 (int flag);
+extern void mutual_test_2 (int flag);
+extern void mutual_test_3 (int flag);
+extern void mutual_test_4 (int flag);
+
+void mutual_test_1 (int flag)
+{
+  marker_A ();
+  if (flag)
+    mutual_test_2 (flag);
+}
+
+void mutual_test_2 (int flag)
+{
+  marker_B ();
+  if (flag)
+    mutual_test_3 (flag);
+}
+
+void mutual_test_3 (int flag)
+{
+  marker_C ();
+  if (flag)
+    mutual_test_4 (flag);
+}
+
+void mutual_test_4 (int flag)
+{
+  marker_D ();
+  if (flag)
+    mutual_test_1 (flag);
+}
diff --git a/gcc/testsuite/gcc.dg/analyzer/loop.c b/gcc/testsuite/gcc.dg/analyzer/loop.c
index 7d1d95d..23294f2 100644
--- a/gcc/testsuite/gcc.dg/analyzer/loop.c
+++ b/gcc/testsuite/gcc.dg/analyzer/loop.c
@@ -13,7 +13,8 @@ void test(void)
       __analyzer_eval (i >= 0); /* { dg-warning "TRUE" } */
   }
 
-  __analyzer_eval (i >= 256); /* { dg-warning "TRUE" "" { xfail *-*-* } } */
+  __analyzer_eval (i >= 256); /* { dg-warning "TRUE" } */
   __analyzer_eval (i == 256); /* { dg-warning "TRUE" "" { xfail *-*-* } } */
-  /* TODO(xfail): we're not reaching the end of the loop.  */
+  /* { dg-warning "UNKNOWN" "" { target *-*-* } .-1 } */
+  /* TODO(xfail^^^): it only figures out i >= 256, rather than i == 256.  */
 }
diff --git a/gcc/testsuite/gcc.dg/analyzer/malloc-1.c b/gcc/testsuite/gcc.dg/analyzer/malloc-1.c
index 128dfe9..e30ff3c 100644
--- a/gcc/testsuite/gcc.dg/analyzer/malloc-1.c
+++ b/gcc/testsuite/gcc.dg/analyzer/malloc-1.c
@@ -88,9 +88,7 @@ void test_10 (void)
     foo ();
 
   free (ptr);
-  free (ptr); /* { dg-warning "double-free of 'ptr'" "" { xfail *-*-* } } */ 
-  /* TODO(xfail): it's stopping after the 1st time through the loop,
-     with a cache hit, and thus not seeing the end of the function.  */
+  free (ptr); /* { dg-warning "double-free of 'ptr'" } */ 
 }
 
 void test_11 (void)
@@ -239,9 +237,7 @@ void test_22 (void)
     foo ();
 
   free (ptr);
-  free (ptr); /* { dg-warning "double-free of 'ptr'" "" { xfail *-*-* } } */ 
-  /* TODO(xfail): it's stopping after the 1st time through the loop,
-     with a cache hit, and thus not seeing the end of the function.  */
+  free (ptr); /* { dg-warning "double-free of 'ptr'" } */ 
 }
 
 int *test_23 (int n)
diff --git a/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-12.c b/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-12.c
index 3a2e2bb..c8361d5 100644
--- a/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-12.c
+++ b/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-12.c
@@ -2,7 +2,7 @@
 
 void recursive_free (void *ptr)
 {
-  free (ptr);
+  free (ptr); /* { dg-warning "double-free of 'ptr'" } */
   recursive_free (ptr);
   /* TODO: should we warn for this?  */
 }
diff --git a/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-8-double-free.c b/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-8-double-free.c
index 62e7302..7c27998 100644
--- a/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-8-double-free.c
+++ b/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-8-double-free.c
@@ -1,21 +1,17 @@
 /* Example of a multilevel wrapper around malloc/free, with a double-free.  */
 
-/* { dg-options "--analyzer -fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdump-analyzer-summaries -fanalyzer-checker=malloc -fanalyzer-verbose-state-changes" } */
+/* { dg-options "--analyzer -fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fanalyzer-checker=malloc -fanalyzer-verbose-state-changes" } */
 
 #include <stdlib.h>
 
-void *wrapped_malloc (size_t size) /* { dg-warning "summary: add: '<return-value>': 'start' -> 'unchecked'" } */
+void *wrapped_malloc (size_t size)
 {
   return malloc (size);
 }
 
-void wrapped_free (void *ptr) /* { dg-warning "summary: add: 'ptr': 'start' -> 'free'" } */
-/* { dg-warning "summary: transition: 'ptr': 'nonnull' -> 'free'" "" { target *-*-* } .-1 } */
-/* { dg-warning "summary: transition: 'ptr': 'free' -> 'stop'" "" { target *-*-* } .-2 } */
+void wrapped_free (void *ptr)
 {
   free (ptr); /* { dg-warning "double-free of 'ptr' \\\[CWE-415\\\]" } */
-  /* FIXME: unchecked -> free is correct, but start -> free should be pruned
-     from the path.  */
 }
 
 typedef struct boxed_int
@@ -24,7 +20,7 @@ typedef struct boxed_int
 } boxed_int;
 
 boxed_int *
-make_boxed_int (int i) /* { dg-warning "summary: add: '<return-value>': 'start' -> 'nonnull'" } */
+make_boxed_int (int i)
 {
   boxed_int *result = (boxed_int *)wrapped_malloc (sizeof (boxed_int));
   if (!result)
@@ -34,13 +30,9 @@ make_boxed_int (int i) /* { dg-warning "summary: add: '<return-value>': 'start'
 }
 
 void
-free_boxed_int (boxed_int *bi) /* { dg-warning "summary: add: 'bi': 'start' -> 'free'" } */
-/* { dg-warning "summary: add: 'bi': 'start' -> 'stop'" "" { target *-*-* } .-1 } */
+free_boxed_int (boxed_int *bi)
 {
   wrapped_free (bi);
-  /* FIXME: events here are wrong; they refer to ptr, not bi.
-     (was "state of 'ptr': 'start' -> 'free'")
-     Also, they should be just start->free, or be skipped.  */
 }
 
 void test (int i)
@@ -52,8 +44,6 @@ void test (int i)
   free_boxed_int (obj);
 }
 
-/* TODO: various strange entries in the path.  */
-
 /* Double-free.  */
 /* { dg-begin-multiline-output "" }
   'test': events 1-2
@@ -62,102 +52,81 @@ void test (int i)
      |      |      ^~~~
      |      |      |
      |      |      (1) entry to 'test'
-     |   NN | {
-     |   NN |   boxed_int *obj = make_boxed_int (i);
-     |      |                    ~~~~~~~~~~~~~~~~~~
-     |      |                    |
-     |      |                    (2) calling 'make_boxed_int' from 'test'
-     |
-     +--> 'make_boxed_int': event 3
-                  |
-                  |   NN | make_boxed_int (int i)
-                  |      | ^~~~~~~~~~~~~~
-                  |      | |
-                  |      | (3) entry to 'make_boxed_int'
-                  |
-          'wrapped_malloc': event 4
-                  |
-                  |   NN | void *wrapped_malloc (size_t size)
-                  |      |       ^~~~~~~~~~~~~~
-                  |      |       |
-                  |      |       (4) entry to 'wrapped_malloc'
-                  |
-     <------------+
-     |
-  'test': events 5-6
-     |
-     |   NN |   boxed_int *obj = make_boxed_int (i);
-     |      |                    ^~~~~~~~~~~~~~~~~~
-     |      |                    |
-     |      |                    (5) returning to 'test' from 'make_boxed_int'
-     |   NN | 
+     |......
      |   NN |   free_boxed_int (obj);
      |      |   ~~~~~~~~~~~~~~~~~~~~
      |      |   |
-     |      |   (6) calling 'free_boxed_int' from 'test'
+     |      |   (2) calling 'free_boxed_int' from 'test'
      |
-     +--> 'free_boxed_int': events 7-9
+     +--> 'free_boxed_int': events 3-4
                   |
                   |   NN | free_boxed_int (boxed_int *bi)
                   |      | ^~~~~~~~~~~~~~
                   |      | |
-                  |      | (7) entry to 'free_boxed_int'
-                  |......
+                  |      | (3) entry to 'free_boxed_int'
+                  |   NN | {
                   |   NN |   wrapped_free (bi);
                   |      |   ~~~~~~~~~~~~~~~~~
                   |      |   |
-                  |      |   (8) state of 'ptr': 'start' -> 'nonnull' (origin: NULL)
-                  |      |   (9) first 'free' here (state of 'ptr': 'start' -> 'free', origin: NULL)
+                  |      |   (4) calling 'wrapped_free' from 'free_boxed_int'
+                  |
+                  +--> 'wrapped_free': events 5-6
+                              |
+                              |   NN | void wrapped_free (void *ptr)
+                              |      |      ^~~~~~~~~~~~
+                              |      |      |
+                              |      |      (5) entry to 'wrapped_free'
+                              |   NN | {
+                              |   NN |   free (ptr);
+                              |      |   ~~~~~~~~~~
+                              |      |   |
+                              |      |   (6) first 'free' here (state of 'ptr': 'nonnull' -> 'free', origin: NULL)
+                              |
+                  <-----------+
+                  |
+          'free_boxed_int': event 7
+                  |
+                  |   NN |   wrapped_free (bi);
+                  |      |   ^~~~~~~~~~~~~~~~~
+                  |      |   |
+                  |      |   (7) returning to 'free_boxed_int' from 'wrapped_free'
                   |
-          'wrapped_free': events 10-12
-                 |
-                 |   NN | void wrapped_free (void *ptr)
-                 |      |      ^~~~~~~~~~~~
-                 |      |      |
-                 |      |      (10) entry to 'wrapped_free'
-                 |......
-                 |   NN |   free (ptr);
-                 |      |   ~~~~~~~~~~
-                 |      |   |
-                 |      |   (11) first 'free' here (state of 'ptr': 'start' -> 'free', origin: NULL)
-                 |      |   (12) first 'free' here (state of 'ptr': 'nonnull' -> 'free', origin: NULL)
-                 |
-     <-----------+
+     <------------+
      |
-  'test': events 13-14
+  'test': events 8-9
      |
      |   NN |   free_boxed_int (obj);
      |      |   ^~~~~~~~~~~~~~~~~~~~
      |      |   |
-     |      |   (13) returning to 'test' from 'free_boxed_int'
+     |      |   (8) returning to 'test' from 'free_boxed_int'
      |   NN | 
      |   NN |   free_boxed_int (obj);
      |      |   ~~~~~~~~~~~~~~~~~~~~
      |      |   |
-     |      |   (14) calling 'free_boxed_int' from 'test'
+     |      |   (9) calling 'free_boxed_int' from 'test'
      |
-     +--> 'free_boxed_int': events 15-16
+     +--> 'free_boxed_int': events 10-11
                   |
                   |   NN | free_boxed_int (boxed_int *bi)
                   |      | ^~~~~~~~~~~~~~
                   |      | |
-                  |      | (15) entry to 'free_boxed_int'
-                  |......
+                  |      | (10) entry to 'free_boxed_int'
+                  |   NN | {
                   |   NN |   wrapped_free (bi);
                   |      |   ~~~~~~~~~~~~~~~~~
                   |      |   |
-                  |      |   (16) calling 'wrapped_free' from 'free_boxed_int'
+                  |      |   (11) calling 'wrapped_free' from 'free_boxed_int'
                   |
-                  +--> 'wrapped_free': events 17-18
+                  +--> 'wrapped_free': events 12-13
                               |
                               |   NN | void wrapped_free (void *ptr)
                               |      |      ^~~~~~~~~~~~
                               |      |      |
-                              |      |      (17) entry to 'wrapped_free'
-                              |......
+                              |      |      (12) entry to 'wrapped_free'
+                              |   NN | {
                               |   NN |   free (ptr);
                               |      |   ~~~~~~~~~~
                               |      |   |
-                              |      |   (18) second 'free' here ('ptr' is in state 'free')
+                              |      |   (13) second 'free' here ('ptr' is in state 'free')
                               |
    { dg-end-multiline-output "" } */
diff --git a/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-8-unchecked.c b/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-8-unchecked.c
index 48680e0..f19370c 100644
--- a/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-8-unchecked.c
+++ b/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-8-unchecked.c
@@ -1,10 +1,10 @@
-/* Example of an  multilevel wrapper around malloc, with an unchecked write.  */
+/* Example of a multilevel wrapper around malloc, with an unchecked write.  */
 
-/* { dg-options "--analyzer -fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdump-analyzer-summaries -fanalyzer-checker=malloc -fanalyzer-verbose-state-changes" } */
+/* { dg-options "--analyzer -fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fanalyzer-checker=malloc -fanalyzer-verbose-state-changes" } */
 
 #include <stdlib.h>
 
-void *wrapped_malloc (size_t size) /* { dg-warning "summary: add: '<return-value>': 'start' -> 'unchecked'" } */
+void *wrapped_malloc (size_t size)
 {
   return malloc (size); /* { dg-message "this call could return NULL" } */
 }
@@ -15,7 +15,7 @@ typedef struct boxed_int
 } boxed_int;
 
 boxed_int *
-make_boxed_int (int i) /* { dg-warning "summary: add: '<return-value>': 'start' -> 'nonnull'" } */
+make_boxed_int (int i)
 {
   boxed_int *result = (boxed_int *)wrapped_malloc (sizeof (boxed_int));
   result->i = i; /* { dg-warning "use of possibly-NULL 'result'" } */
@@ -24,6 +24,8 @@ make_boxed_int (int i) /* { dg-warning "summary: add: '<return-value>': 'start'
 }
 
 /* "use of possibly-NULL 'result' [CWE-690]".  */
+/* TODO: the state of '<return-value>': 'start' -> 'unchecked' message
+   is somewhat redundant.  */
 /* { dg-begin-multiline-output "" }
   'make_boxed_int': events 1-2
           |
@@ -37,7 +39,7 @@ make_boxed_int (int i) /* { dg-warning "summary: add: '<return-value>': 'start'
           |      |                                    |
           |      |                                    (2) calling 'wrapped_malloc' from 'make_boxed_int'
           |
-          +--> 'wrapped_malloc': events 3-4
+          +--> 'wrapped_malloc': events 3-5
                        |
                        |   NN | void *wrapped_malloc (size_t size)
                        |      |       ^~~~~~~~~~~~~~
@@ -47,19 +49,20 @@ make_boxed_int (int i) /* { dg-warning "summary: add: '<return-value>': 'start'
                        |   NN |   return malloc (size);
                        |      |          ~~~~~~~~~~~~~
                        |      |          |
-                       |      |          (4) this call could return NULL (state of '<return-value>': 'start' -> 'unchecked', origin: NULL)
+                       |      |          (4) this call could return NULL (state of '<unknown>': 'start' -> 'unchecked', origin: NULL)
+                       |      |          (5) state of '<return-value>': 'start' -> 'unchecked' (origin: '<unknown>')
                        |
           <------------+
           |
-  'make_boxed_int': events 5-6
+  'make_boxed_int': events 6-7
           |
           |   NN |   boxed_int *result = (boxed_int *)wrapped_malloc (sizeof (boxed_int));
           |      |                                    ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
           |      |                                    |
-          |      |                                    (5) returning to 'make_boxed_int' from 'wrapped_malloc'
+          |      |                                    (6) returning to 'make_boxed_int' from 'wrapped_malloc'
           |   NN |   result->i = i;
           |      |   ~~~~~~~~~~~~~                     
           |      |             |
-          |      |             (6) 'result' could be NULL ('result' is in state 'unchecked')
+          |      |             (7) 'result' could be NULL ('result' is in state 'unchecked')
           |
   { dg-end-multiline-output "" } */
diff --git a/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-9.c b/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-9.c
index e998e22..325fa44 100644
--- a/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-9.c
+++ b/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-9.c
@@ -6,7 +6,8 @@ void
 two_frees (void *p, void *q)
 {
   free (p);
-  free (q);
+  free (q); /* { dg-warning "double-free of 'q'" } */
+  /* TODO: could be useful to identify that p == q when called from 'test'.  */
 }
 
 extern void do_stuff (void);
@@ -15,5 +16,3 @@ void test (void *ptr)
 {
   two_frees (ptr, ptr);
 }
-
-/* FIXME: shouldn't we warn for this?  */
diff --git a/gcc/testsuite/gcc.dg/analyzer/malloc-paths-5.c b/gcc/testsuite/gcc.dg/analyzer/malloc-paths-5.c
index 081c83c..7fdc8a1 100644
--- a/gcc/testsuite/gcc.dg/analyzer/malloc-paths-5.c
+++ b/gcc/testsuite/gcc.dg/analyzer/malloc-paths-5.c
@@ -35,6 +35,6 @@ int test (const char *filename, int flag)
   /* { dg-message "\\(3\\) first 'free' here" "" { target *-*-* } first_free_of_p } */
   /* { dg-message "\\(4\\) second 'free' here" "" { target *-*-* } second_free_of_p } */
 
-  /* We dont' care about the state changes to q.  */
+  /* We don't care about the state changes to q.  */
   /* TODO: we do care about the test of q.  */
 }
diff --git a/gcc/testsuite/gcc.dg/analyzer/params-2.c b/gcc/testsuite/gcc.dg/analyzer/params-2.c
index a670283..1584ebd 100644
--- a/gcc/testsuite/gcc.dg/analyzer/params-2.c
+++ b/gcc/testsuite/gcc.dg/analyzer/params-2.c
@@ -12,9 +12,5 @@ void test(int i, int j)
 
   ensure_equal (i, j);
 
-  __analyzer_eval (i == j); /* { dg-warning "TRUE" "" { xfail *-*-* } } */
-  /* { dg-warning "UNKNOWN" "" { target *-*-* } .-1 } */
-  /* TODO(xfail): follow_call doesn't capture state changes within the
-     function into the resulting path_state, and so we don't retain the
-     "a@1 == i@0" etc info.  */
+  __analyzer_eval (i == j); /* { dg-warning "TRUE" } */
 }
diff --git a/gcc/testsuite/gcc.dg/analyzer/params.c b/gcc/testsuite/gcc.dg/analyzer/params.c
index 2ef0bac..ff405f2 100644
--- a/gcc/testsuite/gcc.dg/analyzer/params.c
+++ b/gcc/testsuite/gcc.dg/analyzer/params.c
@@ -2,9 +2,7 @@ static int called_function(int j)
 {
   int k;
 
-  __analyzer_eval (j > 4); /* { dg-warning "TRUE" "" { xfail *-*-* } } */
-  /* { dg-warning "UNKNOWN" "" { target *-*-* } .-1 } */
-  /* TODO(xfail): we're not passing on the knowledge from the callsite in test.  */
+  __analyzer_eval (j > 4); /* { dg-warning "TRUE" } */
 
   k = j - 1;
 
-- 
1.8.5.3

